# This file is part of Indico.
# Copyright (C) 2002 - 2018 European Organization for Nuclear Research (CERN).
#
# Indico is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.
#
# Indico is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Indico; if not, see <http://www.gnu.org/licenses/>.

# isort:skip_file
# skipping just a single import is not enough as it does not prevent
# isort from moving imports before the skipped line

from __future__ import absolute_import, unicode_literals

# XXX: keep `simple` on top; other modules may need fields from there (especially JSONField)
from .simple import (EmailListField, HiddenFieldList, IndicoEmailRecipientsField, IndicoPasswordField, IndicoRadioField,
                     IndicoSelectMultipleCheckboxBooleanField, IndicoSelectMultipleCheckboxField, IndicoStaticTextField,
                     IndicoTagListField, JSONField, TextListField)

from .colors import IndicoPalettePickerField, IndicoSinglePalettePickerField
from .datetime import (IndicoDateField, IndicoDateTimeField, IndicoTimezoneSelectField, IndicoWeekDayRepetitionField,
                       OccurrencesField, RelativeDeltaField, TimeDeltaField)
from .enums import HiddenEnumField, IndicoEnumRadioField, IndicoEnumSelectField
from .files import EditableFileField, FileField
from .itemlists import MultipleItemsField, MultiStringField, OverrideMultipleItemsField
from .location import IndicoLocationField
from .markdown import IndicoMarkdownField
from .principals import AccessControlListField, PrincipalField, PrincipalListField
from .protection import IndicoProtectionField
from .sqlalchemy import IndicoQuerySelectMultipleCheckboxField, IndicoQuerySelectMultipleField


__all__ = ('IndicoSelectMultipleCheckboxField', 'IndicoRadioField', 'JSONField', 'HiddenFieldList', 'TextListField',
           'EmailListField', 'IndicoPasswordField', 'IndicoStaticTextField', 'IndicoTagListField',
           'IndicoPalettePickerField', 'IndicoSinglePalettePickerField', 'TimeDeltaField', 'IndicoDateTimeField',
           'OccurrencesField', 'IndicoTimezoneSelectField', 'IndicoEnumSelectField', 'IndicoEnumRadioField',
           'HiddenEnumField', 'FileField', 'MultiStringField', 'MultipleItemsField', 'OverrideMultipleItemsField',
           'PrincipalListField', 'PrincipalField', 'AccessControlListField', 'IndicoQuerySelectMultipleField',
           'EditableFileField', 'IndicoQuerySelectMultipleCheckboxField', 'IndicoLocationField', 'IndicoMarkdownField',
           'IndicoDateField', 'IndicoProtectionField', 'IndicoSelectMultipleCheckboxBooleanField', 'RelativeDeltaField',
           'IndicoWeekDayRepetitionField', 'IndicoEmailRecipientsField')
